/****************************************************************************
** Form interface generated from reading ui file 'src/mypasswordsafe.ui'
**
** Created by User Interface Compiler
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/

#ifndef MYPASSWORDSAFE_H
#define MYPASSWORDSAFE_H

#include <qvariant.h>
#include <qpixmap.h>
#include <qmainwindow.h>
#include <string>
#include <qsettings.h>
#include "safe.hpp"
#include "manualdlg.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QAction;
class QActionGroup;
class QToolBar;
class QPopupMenu;
class SafeListView;
class QListViewItem;
class SafeListViewItem;
class Idle;
class QTimer;
class PwordEditDlg;
class Clipboard;

class MyPasswordSafe : public QMainWindow
{
    Q_OBJECT

public:
    MyPasswordSafe( QWidget* parent = 0, const char* name = 0, WFlags fl = WType_TopLevel );
    ~MyPasswordSafe();

    SafeListView* pwordListView;
    QMenuBar *menubar;
    QPopupMenu *fileMenu;
    QPopupMenu *PopupMenu;
    QPopupMenu *PopupMenu_2;
    QPopupMenu *helpMenu;
    QToolBar *toolBar;
    QAction* fileNewAction;
    QAction* fileOpenAction;
    QAction* fileSaveAction;
    QAction* fileSaveAsAction;
    QAction* fileExitAction;
    QAction* helpAboutAction;
    QAction* pwordAddAction;
    QAction* pwordDeleteAction;
    QAction* pwordEditAction;
    QAction* pwordFetchAction;
    QAction* fileMakeDefaultAction;
    QAction* filePrefAction;
    QAction* helpWhatsThisAction;
    QAction* pwordFetchUserAction;
    QAction* helpManualAction;
    QAction* fileOpenDefaultAction;
    QAction* changePassPhraseAction;
    QAction* editUndoAction;
    QAction* editRedoAction;
    QAction* lockAction;
    QAction* lockOnMinimizeAction;
    QAction* settingsGenerateAndShow;
    QAction* settingsGenerateAndFetch;
    QAction* settingsGenerateOnNew;
    QAction* createGroupAction;
    QAction* clearClipboardOnExitAction;
    QAction* settingsDetailsAction;
    QAction* settingsDetailsNameAction;
    QAction* settingsDetailsUserAction;
    QAction* settingsDetailsNotesAction;
    QAction* settingsDetailsLast_ModifiedAction;
    QAction* settingsDetailsLast_AccessedAction;
    QAction* settingsDetailsCreated_OnAction;
    QAction* settingsDetailsLifetimeAction;
    QAction* settingsInstall_clear_timerAction;
    QAction* editClearClipboardAction;

    bool closeSafe();
    virtual bool open( const char * filename, const EncryptedString & passkey );
    virtual bool open( const char * filename, const EncryptedString & passkey, const char * type );
    Safe * getSafe();
    int getGeneratedPwordLength();
    virtual const QString & getDefaultSafe();
    virtual bool browseForSafe( QString & filename, QString & filter, bool saving );
    virtual bool clearClipboardOnExit() const;
    virtual bool lockOnMinimize() const;
    virtual void readConfig();
    virtual void readColumnWidth( int col, const char * name );
    virtual void writeColumnWidth( int col, const char * name );
    virtual void writeConfig();
    virtual bool firstTime() const;
    virtual bool isMinimized() const;
    virtual void hideChildren();
    virtual void showChildren();
    virtual SafeGroup * getSelectedParent() const;
    virtual void setClearTimeOut(unsigned int);
    virtual unsigned int clearTimeOut();

public slots:
    virtual void fileNew();
    virtual void fileExit();
    virtual void fileMakeDefault();
    virtual void filePreferences();
    virtual void fileOpen();
    virtual bool save();
    virtual bool saveAs();
    virtual void pwordAdd();
    virtual void pwordDelete();
    virtual void deleteItem( SafeItem * item );
    virtual void pwordEdit();
    virtual void pwordFetch();
    virtual void pwordFetchUser();
    virtual void onPwordListDblClicked( QListViewItem * item );
    virtual void onPwordListRightClk( QListViewItem *, const QPoint & point, int );
    virtual void helpAbout( int page );
    virtual void helpManual();
    virtual void setDefaultSafe( const QString & path );
    virtual void createNewSafe( const EncryptedString & passphrase );
    virtual void fileOpenDefault();
    virtual void fileChangePassPhrase();
    virtual void lock();
    virtual void createGroup();
    virtual void setClearClipboardOnExit( bool yes );
    virtual void setLockOnMinimize( bool yes );
    virtual void setGenerateAndShow( bool yes);
    virtual void setGenerateAndFetch( bool yes);
    virtual void setGenerateOnNew( bool yes);
    virtual void hideEvent( QHideEvent * );
    virtual void showEvent( QShowEvent * );
    virtual void dragObjectDropped( QMimeSource * drag, SafeListViewItem * target );
    virtual void clipboardCleared();
    virtual void helpAbout();
    virtual void savingEnabled();
    virtual void savingEnabled(bool);
    virtual void slotSecondsIdle(int);
    virtual void checkMinimization();
    virtual void editDialogAccepted();
    virtual void editDialogRejected();

signals:
    void quit();

protected:
    virtual bool createEditDialog(SafeEntry *);

    QHBoxLayout* MyPasswordSafeLayout;

protected slots:
    virtual void languageChange();

    virtual void closeEvent( QCloseEvent * e );


private:
    ManualDlg m_manual;
    int m_name_width, m_user_width, m_notes_width, m_max_tries;
    QString m_default_safe;
    bool m_clear_clipboard;
    QString m_def_user;
    Safe *m_safe;
    unsigned int m_gen_pword_length;
    QSettings m_config;
    bool m_do_lock;
    bool m_first_time;
    Idle *m_idle;
    int m_idle_timeout;
    QPtrList<PwordEditDlg> m_children;
    Clipboard *m_clipboard;

    QPixmap image0;

    void init();
    void destroy();
    virtual bool removeEditDialog(const PwordEditDlg *);

};

#endif // MYPASSWORDSAFE_H
